#include "scriptnode.h"
#include "engine.h"
#include "sparrowshell/sparrowshell.h"
#include <iostream>
#define LUASETFUN(var) m_script.set_function(#var,&ScriptNode::var,this)

ScriptNode::ScriptNode()
{
    LUASETFUN(print);
}

void ScriptNode::update(){
    static bool test = true;
    if(test)
        test=false;
}

void ScriptNode::print(std::string to_print){
    std::wstring ws;
    to_print.append("\n");
    ws.assign(to_print.begin(),to_print.end());
    this->getEngine().getShell()->out(ws);
}

void ScriptNode::execute(std::wstring to_execute){
    try{
        std::string str;
        str.assign(to_execute.begin(),to_execute.end());
        m_script.script(str);
    }catch(sol::error error_lua){
        std::string s = error_lua.what();
        std::wstring ws;
        ws.assign(s.begin(),s.end());
        this->getEngine().getShell()->out(ws,glm::vec3(1,0,0));
    }
}
